diff --git a/projects/openttd_vs80.vcproj b/projects/openttd_vs80.vcproj
index ef5e2f9..6b1b543 100644
--- a/projects/openttd_vs80.vcproj
+++ b/projects/openttd_vs80.vcproj
@@ -672,6 +672,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\pbs.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\players.cpp"
 				>
 			</File>
@@ -1308,6 +1312,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\pbs.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\player_base.h"
 				>
 			</File>
diff --git a/projects/openttd_vs90.vcproj b/projects/openttd_vs90.vcproj
index 2e6224d..85ad78a 100644
--- a/projects/openttd_vs90.vcproj
+++ b/projects/openttd_vs90.vcproj
@@ -669,6 +669,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\pbs.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\players.cpp"
 				>
 			</File>
@@ -1305,6 +1309,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\pbs.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\player_base.h"
 				>
 			</File>
diff --git a/source.list b/source.list
index 4e873c2..275318b 100644
--- a/source.list
+++ b/source.list
@@ -59,6 +59,7 @@ os_timer.cpp
 	ottdres.rc
 #end
 pathfind.cpp
+pbs.cpp
 players.cpp
 queue.cpp
 rail.cpp
@@ -252,6 +253,7 @@ order_func.h
 order_type.h
 core/overflowsafe_type.hpp
 pathfind.h
+pbs.h
 player_base.h
 player_face.h
 player_func.h
diff --git a/src/debug.cpp b/src/debug.cpp
index fb1e28a..c4970aa 100644
--- a/src/debug.cpp
+++ b/src/debug.cpp
@@ -31,6 +31,7 @@ int _debug_freetype_level;
 int _debug_sl_level;
 int _debug_station_level;
 int _debug_gamelog_level;
+int _debug_pbs_level;
 
 
 struct DebugLevel {
@@ -56,6 +57,7 @@ struct DebugLevel {
 	DEBUG_LEVEL(sl),
 	DEBUG_LEVEL(station),
 	DEBUG_LEVEL(gamelog),
+	DEBUG_LEVEL(pbs),
 	};
 #undef DEBUG_LEVEL
 
diff --git a/src/debug.h b/src/debug.h
index 4048c16..127021d 100644
--- a/src/debug.h
+++ b/src/debug.h
@@ -48,6 +48,7 @@
 	extern int _debug_sl_level;
 	extern int _debug_station_level;
 	extern int _debug_gamelog_level;
+	extern int _debug_pbs_level;
 
 	void CDECL debug(const char *dbg, ...);
 	void CDECL debug_print(const char *dbg, const char *buf);
diff --git a/src/genworld_gui.cpp b/src/genworld_gui.cpp
index e080973..7296346 100644
--- a/src/genworld_gui.cpp
+++ b/src/genworld_gui.cpp
@@ -477,7 +477,7 @@ struct GenerateLandscapeWindow : public QueryStringBaseWindow {
 			* (use random seed) it should not be possible to be
 			* entered into the input field; the generate seed
 			* button can be used instead. */
-		_settings_newgame.game_creation.generation_seed = minu(strtoul(this->edit_str_buf, NULL, 10), MAX_UVALUE(uint32) - 1);
+		_settings_newgame.game_creation.generation_seed = minu(strtoul(this->edit_str_buf, NULL, sizeof(this->edit_str_buf) - 1), MAX_UVALUE(uint32) - 1);
 		return state;
 	}
 
diff --git a/src/gfx.cpp b/src/gfx.cpp
index 676e68f..ac9e32f 100644
--- a/src/gfx.cpp
+++ b/src/gfx.cpp
@@ -689,7 +689,7 @@ void DrawSprite(SpriteID img, SpriteID pal, int x, int y, const SubSprite *sub)
 	}
 }
 
-static void GfxMainBlitter(const Sprite *sprite, int x, int y, BlitterMode mode, const SubSprite *sub)
+static inline void GfxMainBlitter(const Sprite *sprite, int x, int y, BlitterMode mode, const SubSprite *sub)
 {
 	const DrawPixelInfo *dpi = _cur_dpi;
 	Blitter::BlitterParams bp;
@@ -715,8 +715,8 @@ static void GfxMainBlitter(const Sprite *sprite, int x, int y, BlitterMode mode,
 	bp.height = UnScaleByZoom(sprite->height - clip_top - clip_bottom, dpi->zoom);
 	bp.top = 0;
 	bp.left = 0;
-	bp.skip_left = UnScaleByZoomLower(clip_left, dpi->zoom);
-	bp.skip_top = UnScaleByZoomLower(clip_top, dpi->zoom);
+	bp.skip_left = UnScaleByZoom(clip_left, dpi->zoom);
+	bp.skip_top = UnScaleByZoom(clip_top, dpi->zoom);
 
 	x += ScaleByZoom(bp.skip_left, dpi->zoom);
 	y += ScaleByZoom(bp.skip_top, dpi->zoom);
@@ -767,9 +767,6 @@ static void GfxMainBlitter(const Sprite *sprite, int x, int y, BlitterMode mode,
 		if (bp.width <= 0) return;
 	}
 
-	assert(bp.skip_left + bp.width <= UnScaleByZoom(sprite->width, dpi->zoom));
-	assert(bp.skip_top + bp.height <= UnScaleByZoom(sprite->height, dpi->zoom));
-
 	BlitterFactoryBase::GetCurrentBlitter()->Draw(&bp, mode, dpi->zoom);
 }
 
diff --git a/src/industry_cmd.cpp b/src/industry_cmd.cpp
index 1338fe9..ae2322f 100644
--- a/src/industry_cmd.cpp
+++ b/src/industry_cmd.cpp
@@ -337,7 +337,8 @@ static Foundation GetFoundation_Industry(TileIndex tile, Slope tileh)
 	IndustryGfx gfx = GetIndustryGfx(tile);
 
 	/* For NewGRF industry tiles we might not be drawing a foundation. We need to
-	 * account for this, as other structures should
+	 * account for this, otherwise we might be applying a FOUNDATION_LEVELED
+	 * on a steep slope which is not allowed. Furthermore other structures should
 	 * draw the wall of the foundation in this case.
 	 */
 	if (gfx >= NEW_INDUSTRYTILEOFFSET) {
diff --git a/src/landscape.cpp b/src/landscape.cpp
index 982f02a..2216a38 100644
--- a/src/landscape.cpp
+++ b/src/landscape.cpp
@@ -79,9 +79,8 @@ uint ApplyFoundationToSlope(Foundation f, Slope *s)
 	if (!IsFoundation(f)) return 0;
 
 	if (IsLeveledFoundation(f)) {
-		uint dz = TILE_HEIGHT + (IsSteepSlope(*s) ? TILE_HEIGHT : 0);
 		*s = SLOPE_FLAT;
-		return dz;
+		return TILE_HEIGHT;
 	}
 
 	if (f != FOUNDATION_STEEP_BOTH && IsNonContinuousFoundation(f)) {
@@ -403,9 +402,6 @@ void DrawFoundation(TileInfo *ti, Foundation f)
 
 			AddSortableSpriteToDraw(inclined_base + inclined, PAL_NONE, ti->x, ti->y, 16, 16, 1, ti->z);
 			OffsetGroundSprite(31, 9);
-		} else if (IsLeveledFoundation(f)) {
-			AddSortableSpriteToDraw(leveled_base + SlopeWithOneCornerRaised(highest_corner), PAL_NONE, ti->x, ti->y, 16, 16, 7, ti->z - TILE_HEIGHT);
-			OffsetGroundSprite(31, 1);
 		} else if (f == FOUNDATION_STEEP_LOWER) {
 			/* one corner raised */
 			OffsetGroundSprite(31, 1);
diff --git a/src/map_func.h b/src/map_func.h
index a4b3991..41845ad 100644
--- a/src/map_func.h
+++ b/src/map_func.h
@@ -268,6 +268,23 @@ static inline TileIndexDiffC TileIndexDiffCByDir(Direction dir)
 	return _tileoffs_by_dir[dir];
 }
 
+/*
+ * Returns the DiagDirection from a TileIndexDiffC.
+ *
+ * @param diff The tile offset
+ * @return The diagonal direction
+ */
+static inline DiagDirection DiagDirByTileIndexDiff(const TileIndexDiffC& diff)
+{
+	assert(diff.x == 0 || diff.y == 0);
+
+	if (diff.x == 0) {
+		return diff.y > 0 ? DIAGDIR_SE : DIAGDIR_NW;
+	} else {
+		return diff.x > 0 ? DIAGDIR_SW : DIAGDIR_NE;
+	}
+}
+
 /**
  * Add a TileIndexDiffC to a TileIndex and returns the new one.
  *
diff --git a/src/misc/dbg_helpers.cpp b/src/misc/dbg_helpers.cpp
index 6db02e8..1c34e25 100644
--- a/src/misc/dbg_helpers.cpp
+++ b/src/misc/dbg_helpers.cpp
@@ -49,7 +49,7 @@ CStrA ValueStr(DiagDirection dd)
 
 /** SignalType short names. */
 static const char* signal_type_names[] = {
-	"NORMAL", "ENTRY", "EXIT", "COMBO",
+	"NORMAL", "ENTRY", "EXIT", "COMBO", "PBS", "NOENTRY",
 };
 
 /** Return name of given SignalType. */
diff --git a/src/misc_gui.cpp b/src/misc_gui.cpp
index a87e0bb..85d9851 100644
--- a/src/misc_gui.cpp
+++ b/src/misc_gui.cpp
@@ -58,13 +58,13 @@ static bool _savegame_sort_dirty;
 
 static const Widget _land_info_widgets[] = {
 {   WWT_CLOSEBOX,   RESIZE_NONE,    14,     0,    10,     0,    13, STR_00C5,                       STR_018B_CLOSE_WINDOW},
-{    WWT_CAPTION,   RESIZE_NONE,    14,    11,   279,     0,    13, STR_01A3_LAND_AREA_INFORMATION, STR_018C_WINDOW_TITLE_DRAG_THIS},
-{      WWT_PANEL,   RESIZE_NONE,    14,     0,   279,    14,    92, 0x0,                            STR_NULL},
+{    WWT_CAPTION,   RESIZE_NONE,    14,    11,   299,     0,    13, STR_01A3_LAND_AREA_INFORMATION, STR_018C_WINDOW_TITLE_DRAG_THIS},
+{      WWT_PANEL,   RESIZE_NONE,    14,     0,   299,    14,    92, 0x0,                            STR_NULL},
 {    WIDGETS_END},
 };
 
 static const WindowDesc _land_info_desc = {
-	WDP_AUTO, WDP_AUTO, 280, 93, 280, 93,
+	WDP_AUTO, WDP_AUTO, 300, 93, 300, 93,
 	WC_LAND_INFO, WC_NONE,
 	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET,
 	_land_info_widgets,
@@ -90,13 +90,13 @@ public:
 		for (uint i = 0; i < LAND_INFO_CENTERED_LINES; i++) {
 			if (StrEmpty(this->landinfo_data[i])) continue;
 
-			DoDrawStringCentered(140, y, this->landinfo_data[i], i == 0 ? TC_LIGHT_BLUE : TC_FROMSTRING);
+			DoDrawStringCentered(150, y, this->landinfo_data[i], i == 0 ? TC_LIGHT_BLUE : TC_FROMSTRING);
 			y += 11;
 		}
 
 		y += 5;
 
-		if (!StrEmpty(this->landinfo_data[LAND_INFO_MULTICENTER_LINE])) DrawStringMultiCenter(140, y, BindCString(this->landinfo_data[LAND_INFO_MULTICENTER_LINE]), this->width - 4);
+		if (!StrEmpty(this->landinfo_data[LAND_INFO_MULTICENTER_LINE])) DrawStringMultiCenter(150, y, BindCString(this->landinfo_data[LAND_INFO_MULTICENTER_LINE]), this->width - 4);
 	}
 
 	LandInfoWindow(TileIndex tile) : Window(&_land_info_desc) {
diff --git a/src/newgrf_station.cpp b/src/newgrf_station.cpp
index 4f57699..5414e11 100644
--- a/src/newgrf_station.cpp
+++ b/src/newgrf_station.cpp
@@ -25,6 +25,7 @@
 #include "player_func.h"
 #include "animated_tile_func.h"
 #include "functions.h"
+#include "rail_map.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -397,7 +398,12 @@ static uint32 StationGetVariable(const ResolverObject *object, byte variable, by
 
 		case 0x42: return GetTerrainType(tile) | (GetRailType(tile) << 8);
 		case 0x43: return st->owner; // Station owner
-		case 0x44: return 2;         // PBS status
+		case 0x44:
+			if (IsTileType(tile, MP_RAILWAY) && IsRailWaypoint(tile)) {
+				return GetWaypointReservation(tile) ? 7 : 4;
+			} else {
+				return GetRailwayStationReservation(tile) ? 7 : 4; // PBS status
+			}
 		case 0x45:
 			if (!HasBit(_svc.valid, 2)) { _svc.v45 = GetRailContinuationInfo(tile); SetBit(_svc.valid, 2); }
 			return _svc.v45;
diff --git a/src/npf.cpp b/src/npf.cpp
index e4498bb..d5f431b 100644
--- a/src/npf.cpp
+++ b/src/npf.cpp
@@ -24,6 +24,7 @@
 #include "vehicle_base.h"
 #include "settings_type.h"
 #include "tunnelbridge.h"
+#include "pbs.h"
 
 static AyStar _npf_aystar;
 
@@ -221,6 +222,23 @@ static uint NPFSlopeCost(AyStarNode* current)
 	 * there is only one level of steepness... */
 }
 
+static uint NPFReservedTrackCost(AyStarNode *current)
+{
+	TileIndex tile = current->tile;
+	TrackBits track = TrackToTrackBits(TrackdirToTrack((Trackdir)current->direction));
+	TrackBits res = GetReservedTrackbits(tile);
+
+	if (NPFGetFlag(current, NPF_FLAG_3RD_SIGNAL) || ((res & track) == TRACK_BIT_NONE && !TracksOverlap(res | track))) return 0;
+
+	if (IsTileType(tile, MP_TUNNELBRIDGE)) {
+		DiagDirection exitdir = TrackdirToExitdir((Trackdir)current->direction);
+		if (GetTunnelBridgeDirection(tile) == ReverseDiagDir(exitdir)) {
+			return  _settings_game.pf.npf.npf_rail_pbs_cross_penalty * (GetTunnelBridgeLength(tile, GetOtherTunnelBridgeEnd(tile)) + 1);
+		}
+	}
+	return  _settings_game.pf.npf.npf_rail_pbs_cross_penalty;
+}
+
 /**
  * Mark tiles by mowing the grass when npf debug level >= 1.
  * Will not work for multiplayer games, since it can (will) cause desyncs.
@@ -354,30 +372,46 @@ static int32 NPFRailPathCost(AyStar* as, AyStarNode* current, OpenListNode* pare
 	/* Determine extra costs */
 
 	/* Check for signals */
-	if (IsTileType(tile, MP_RAILWAY) && HasSignalOnTrackdir(tile, trackdir)) {
-		/* Ordinary track with signals */
-		if (GetSignalStateByTrackdir(tile, trackdir) == SIGNAL_STATE_RED) {
-			/* Signal facing us is red */
-			if (!NPFGetFlag(current, NPF_FLAG_SEEN_SIGNAL)) {
-				/* Penalize the first signal we
-				 * encounter, if it is red */
-
-				/* Is this a presignal exit or combo? */
-				SignalType sigtype = GetSignalType(tile, TrackdirToTrack(trackdir));
-				if (sigtype == SIGTYPE_EXIT || sigtype == SIGTYPE_COMBO) {
-					/* Penalise exit and combo signals differently (heavier) */
-					cost += _settings_game.pf.npf.npf_rail_firstred_exit_penalty;
+	if (IsTileType(tile, MP_RAILWAY)) {
+		if (HasSignalOnTrackdir(tile, trackdir)) {
+			/* Ordinary track with signals */
+			if (GetSignalStateByTrackdir(tile, trackdir) == SIGNAL_STATE_RED) {
+				/* Signal facing us is red */
+				if (!NPFGetFlag(current, NPF_FLAG_SEEN_SIGNAL)) {
+					/* Penalize the first signal we
+					 * encounter, if it is red */
+
+					/* Is this a presignal exit or combo? */
+					SignalType sigtype = GetSignalType(tile, TrackdirToTrack(trackdir));
+					if (!IsPbsSignal(sigtype)) {
+						if (sigtype == SIGTYPE_EXIT || sigtype == SIGTYPE_COMBO) {
+							/* Penalise exit and combo signals differently (heavier) */
+							cost += _settings_game.pf.npf.npf_rail_firstred_exit_penalty;
+						} else {
+							cost += _settings_game.pf.npf.npf_rail_firstred_penalty;
+						}
+					}
+				}
+				/* Record the state of this signal */
+				NPFSetFlag(current, NPF_FLAG_LAST_SIGNAL_RED, true);
+			} else {
+				/* Record the state of this signal */
+				NPFSetFlag(current, NPF_FLAG_LAST_SIGNAL_RED, false);
+			}
+			if (NPFGetFlag(current, NPF_FLAG_SEEN_SIGNAL)) {
+				if (NPFGetFlag(current, NPF_FLAG_2ND_SIGNAL)) {
+					NPFSetFlag(current, NPF_FLAG_3RD_SIGNAL, true);
 				} else {
-					cost += _settings_game.pf.npf.npf_rail_firstred_penalty;
+					NPFSetFlag(current, NPF_FLAG_2ND_SIGNAL, true);
 				}
+			} else {
+				NPFSetFlag(current, NPF_FLAG_SEEN_SIGNAL, true);
 			}
-			/* Record the state of this signal */
-			NPFSetFlag(current, NPF_FLAG_LAST_SIGNAL_RED, true);
-		} else {
-			/* Record the state of this signal */
-			NPFSetFlag(current, NPF_FLAG_LAST_SIGNAL_RED, false);
 		}
-		NPFSetFlag(current, NPF_FLAG_SEEN_SIGNAL, true);
+
+		if (HasPbsSignalOnTrackdir(tile, ReverseTrackdir(trackdir)) && !NPFGetFlag(current, NPF_FLAG_3RD_SIGNAL)) {
+			cost += _settings_game.pf.npf.npf_rail_pbs_signal_back_penalty;
+		}
 	}
 
 	/* Penalise the tile if it is a target tile and the last signal was
@@ -406,7 +440,7 @@ static int32 NPFRailPathCost(AyStar* as, AyStarNode* current, OpenListNode* pare
 	}
 
 	/* Check for occupied track */
-	//TODO
+	cost += NPFReservedTrackCost(current);
 
 	NPFMarkTile(tile);
 	DEBUG(npf, 4, "Calculating G for: (%d, %d). Result: %d", TileX(current->tile), TileY(current->tile), cost);
@@ -422,6 +456,17 @@ static int32 NPFFindDepot(AyStar* as, OpenListNode *current)
 		AYSTAR_FOUND_END_NODE : AYSTAR_DONE;
 }
 
+/** Find any safe and free tile. */
+static int32 NPFFindSafeTile(AyStar *as, OpenListNode *current)
+{
+	const Vehicle *v = ((NPFFindStationOrTileData*)as->user_target)->v;
+
+	return
+		IsSafeWaitingPosition(v, current->path.node.tile, (Trackdir)current->path.node.direction, true, _settings_game.pf.forbid_90_deg) &&
+		IsWaitingPositionFree(v, current->path.node.tile, (Trackdir)current->path.node.direction, _settings_game.pf.forbid_90_deg) ?
+			AYSTAR_FOUND_END_NODE : AYSTAR_DONE;
+}
+
 /* Will find a station identified using the NPFFindStationOrTileData */
 static int32 NPFFindStationOrTile(AyStar* as, OpenListNode *current)
 {
@@ -441,9 +486,48 @@ static int32 NPFFindStationOrTile(AyStar* as, OpenListNode *current)
 	}
 }
 
-/* To be called when current contains the (shortest route to) the target node.
+/**
+ * Find the node containing the first signal on the path.
+ *
+ * If the first signal is on the very first two tiles of the path,
+ * the second signal is returnd. If no suitable signal is present, the
+ * last node of the path is returned.
+ */
+static const PathNode* FindSafePosition(PathNode *path, const Vehicle *v)
+{
+	/* If there is no signal, reserve the whole path. */
+	PathNode *sig = path;
+
+	for(; path->parent != NULL; path = path->parent) {
+		if (IsSafeWaitingPosition(v, path->node.tile, (Trackdir)path->node.direction, true, _settings_game.pf.forbid_90_deg)) {
+			sig = path;
+		}
+	}
+
+	return sig;
+}
+
+/**
+ * Lift the reservation of the tiles from @p start till @p end, excluding @p end itself.
+ */
+static void ClearPathReservation(const PathNode *start, const PathNode *end)
+{
+	bool first_run = true;
+	for (; start != end; start = start->parent) {
+		if (IsRailwayStationTile(start->node.tile) && first_run) {
+			SetRailwayStationPlatformReservation(start->node.tile, TrackdirToExitdir((Trackdir)start->node.direction), false);
+		} else {
+			UnreserveRailTrack(start->node.tile, TrackdirToTrack((Trackdir)start->node.direction));
+		}
+		first_run = false;
+	}
+}
+
+/**
+ * To be called when @p current contains the (shortest route to) the target node.
  * Will fill the contents of the NPFFoundTargetData using
- * AyStarNode[NPF_TRACKDIR_CHOICE].
+ * AyStarNode[NPF_TRACKDIR_CHOICE]. If requested, path reservation
+ * is done here.
  */
 static void NPFSaveTargetData(AyStar* as, OpenListNode* current)
 {
@@ -452,6 +536,40 @@ static void NPFSaveTargetData(AyStar* as, OpenListNode* current)
 	ftd->best_path_dist = current->g;
 	ftd->best_bird_dist = 0;
 	ftd->node = current->path.node;
+	ftd->res_okay = false;
+
+	if (as->user_target != NULL && ((NPFFindStationOrTileData*)as->user_target)->reserve_path && as->user_data[NPF_TYPE] == TRANSPORT_RAIL) {
+		/* Path reservation is requested. */
+		const Vehicle  *v = ((NPFFindStationOrTileData*)as->user_target)->v;
+
+		const PathNode *target = FindSafePosition(&current->path, v);
+		ftd->node = target->node;
+
+		/* If the target is a station skip to platform end. */
+		if (IsRailwayStationTile(target->node.tile)) {
+			DiagDirection dir = TrackdirToExitdir((Trackdir)target->node.direction);
+			uint len = GetStationByTile(target->node.tile)->GetPlatformLength(target->node.tile, dir);
+			TileIndex end_tile = TILE_ADD(target->node.tile, (len - 1) * TileOffsByDiagDir(dir));
+
+			/* Update only end tile, trackdir of a station stays the same. */
+			ftd->node.tile = end_tile;
+			if (!IsWaitingPositionFree(v, end_tile, (Trackdir)target->node.direction, _settings_game.pf.forbid_90_deg)) return;
+			SetRailwayStationPlatformReservation(target->node.tile, dir, true);
+			SetRailwayStationReservation(target->node.tile, false);
+		} else {
+			if (!IsWaitingPositionFree(v, target->node.tile, (Trackdir)target->node.direction, _settings_game.pf.forbid_90_deg)) return;
+		}
+
+		for (const PathNode *cur = target; cur->parent != NULL; cur = cur->parent) {
+			if (!TryReserveRailTrack(cur->node.tile, TrackdirToTrack((Trackdir)cur->node.direction))) {
+				/* Reservation failed, undo. */
+				ClearPathReservation(target, cur);
+				return;
+			}
+		}
+
+		ftd->res_okay = true;
+	}
 }
 
 /**
@@ -713,16 +831,28 @@ static void NPFFollowTrack(AyStar* aystar, OpenListNode* current)
 		}
 	}
 
+	if (NPFGetFlag(&current->path.node, NPF_FLAG_IGNORE_RESERVED)) {
+		/* Mask out any reserved tracks. */
+		TrackBits reserved = GetReservedTrackbits(dst_tile);
+		trackdirbits &= ~TrackBitsToTrackdirBits(reserved);
+
+		uint bits = TrackdirBitsToTrackBits(trackdirbits);
+		int i;
+		FOR_EACH_SET_BIT(i, bits) {
+			if (TracksOverlap(reserved | TrackToTrackBits((Track)i))) trackdirbits &= ~TrackToTrackdirBits((Track)i);
+		}
+	}
+
 	/* Enumerate possible track */
 	uint i = 0;
 	while (trackdirbits != 0) {
 		Trackdir dst_trackdir = RemoveFirstTrackdir(&trackdirbits);
 		DEBUG(npf, 5, "Expanded into trackdir: %d, remaining trackdirs: 0x%X", dst_trackdir, trackdirbits);
 
-		/* Check for oneway signal against us */
+		/* Tile with signals? */
 		if (IsTileType(dst_tile, MP_RAILWAY) && GetRailTileType(dst_tile) == RAIL_TILE_SIGNALS) {
-			if (HasSignalOnTrackdir(dst_tile, ReverseTrackdir(dst_trackdir)) && !HasSignalOnTrackdir(dst_tile, dst_trackdir))
-				/* if one way signal not pointing towards us, stop going in this direction. */
+			if (HasSignalOnTrackdir(dst_tile, ReverseTrackdir(dst_trackdir)) && !HasSignalOnTrackdir(dst_tile, dst_trackdir) && IsOnewaySignal(dst_tile, TrackdirToTrack(dst_trackdir)))
+				/* If there's a one-way signal not pointing towards us, stop going in this direction. */
 				break;
 		}
 		{
@@ -782,7 +912,9 @@ static NPFFoundTargetData NPFRouteInternal(AyStarNode* start1, bool ignore_start
 	/* Initialize result */
 	result.best_bird_dist = (uint)-1;
 	result.best_path_dist = (uint)-1;
-	result.best_trackdir = INVALID_TRACKDIR;
+	result.best_trackdir  = INVALID_TRACKDIR;
+	result.node.tile      = INVALID_TILE;
+	result.res_okay       = false;
 	_npf_aystar.user_path = &result;
 
 	/* Initialize target */
@@ -868,7 +1000,7 @@ NPFFoundTargetData NPFRouteToDepotTrialError(TileIndex tile, Trackdir trackdir,
 	 */
 	Queue depots;
 	int r;
-	NPFFoundTargetData best_result = {(uint)-1, (uint)-1, INVALID_TRACKDIR, {INVALID_TILE, 0, {0, 0}}};
+	NPFFoundTargetData best_result = {(uint)-1, (uint)-1, INVALID_TRACKDIR, {INVALID_TILE, 0, {0, 0}}, false};
 	NPFFoundTargetData result;
 	NPFFindStationOrTileData target;
 	AyStarNode start;
@@ -956,6 +1088,30 @@ NPFFoundTargetData NPFRouteToDepotTrialError(TileIndex tile, Trackdir trackdir,
 	return best_result;
 }
 
+NPFFoundTargetData NPFRouteToSafeTile(const Vehicle *v, TileIndex tile, Trackdir trackdir, bool override_railtype)
+{
+	assert(v->type == VEH_TRAIN);
+
+	NPFFindStationOrTileData fstd;
+	fstd.v = v;
+	fstd.reserve_path = true;
+
+	AyStarNode start1;
+	start1.tile = tile;
+	/* We set this in case the target is also the start tile, we will just
+	 * return a not found then */
+	start1.user_data[NPF_TRACKDIR_CHOICE] = INVALID_TRACKDIR;
+	start1.direction = trackdir;
+	NPFSetFlag(&start1, NPF_FLAG_IGNORE_RESERVED, true);
+
+	RailTypes railtypes = v->u.rail.compatible_railtypes;
+	if (override_railtype) railtypes |= GetRailTypeInfo(v->u.rail.railtype)->compatible_railtypes;
+
+	/* perform a breadth first search. Target is NULL,
+	 * since we are just looking for any safe tile...*/
+	return NPFRouteInternal(&start1, true, NULL, false, &fstd, NPFFindSafeTile, NPFCalcZero, TRANSPORT_RAIL, 0, v->owner, railtypes, 0);
+}
+
 void InitializeNPF()
 {
 	static bool first_init = true;
@@ -973,7 +1129,7 @@ void InitializeNPF()
 	_npf_aystar.max_search_nodes = _settings_game.pf.npf.npf_max_search_nodes;
 }
 
-void NPFFillWithOrderData(NPFFindStationOrTileData* fstd, Vehicle* v)
+void NPFFillWithOrderData(NPFFindStationOrTileData *fstd, Vehicle *v, bool reserve_path)
 {
 	/* Ships don't really reach their stations, but the tile in front. So don't
 	 * save the station id for ships. For roadvehs we don't store it either,
@@ -989,4 +1145,6 @@ void NPFFillWithOrderData(NPFFindStationOrTileData* fstd, Vehicle* v)
 		fstd->dest_coords = v->dest_tile;
 		fstd->station_index = INVALID_STATION;
 	}
+	fstd->reserve_path = reserve_path;
+	fstd->v = v;
 }
diff --git a/src/npf.h b/src/npf.h
index 5a70b6b..bf19b62 100644
--- a/src/npf.h
+++ b/src/npf.h
@@ -45,6 +45,8 @@ enum {
 struct NPFFindStationOrTileData {
 	TileIndex dest_coords;   ///< An indication of where the station is, for heuristic purposes, or the target tile
 	StationID station_index; ///< station index we're heading for, or INVALID_STATION when we're heading for a tile
+	bool      reserve_path;  ///< Indicates whether the found path should be reserved
+	const Vehicle* v;        ///< The vehicle we are pathfinding for
 };
 
 /* Indices into AyStar.userdata[] */
@@ -64,9 +66,13 @@ enum {
 /* Flags for AyStarNode.userdata[NPF_NODE_FLAGS]. Use NPFGetBit() and NPFGetBit() to use them. */
 enum NPFNodeFlag {
 	NPF_FLAG_SEEN_SIGNAL,       ///< Used to mark that a signal was seen on the way, for rail only
+	NPF_FLAG_2ND_SIGNAL,        ///< Used to mark that two signals were seen, rail only
+	NPF_FLAG_3RD_SIGNAL,        ///< Used to mark that three signals were seen, rail only
 	NPF_FLAG_REVERSE,           ///< Used to mark that this node was reached from the second start node, if applicable
 	NPF_FLAG_LAST_SIGNAL_RED,   ///< Used to mark that the last signal on this path was red
 	NPF_FLAG_IGNORE_START_TILE, ///< Used to mark that the start tile is invalid, and searching should start from the second tile on
+	NPF_FLAG_TARGET_RESERVED,   ///< Used to mark that the possible reservation target is already reserved
+	NPF_FLAG_IGNORE_RESERVED,   ///< Used to mark that reserved tiles should be considered impassable
 };
 
 /* Meant to be stored in AyStar.userpath */
@@ -75,6 +81,7 @@ struct NPFFoundTargetData {
 	uint best_path_dist;    ///< The shortest path. Is (uint)-1 if no path is found
 	Trackdir best_trackdir; ///< The trackdir that leads to the shortest path/closest birds dist
 	AyStarNode node;        ///< The node within the target the search led us to
+	bool res_okay;          ///< True if a path reservation could be made
 };
 
 /* These functions below are _not_ re-entrant, in favor of speed! */
@@ -105,7 +112,13 @@ NPFFoundTargetData NPFRouteToDepotBreadthFirstTwoWay(TileIndex tile1, Trackdir t
  * of choices and accurate heuristics, such as water. */
 NPFFoundTargetData NPFRouteToDepotTrialError(TileIndex tile, Trackdir trackdir, bool ignore_start_tile, TransportType type, uint sub_type, Owner owner, RailTypes railtypes);
 
-void NPFFillWithOrderData(NPFFindStationOrTileData* fstd, Vehicle* v);
+/**
+ * Search for any safe tile using a breadth first search and try to reserve a path.
+ */
+NPFFoundTargetData NPFRouteToSafeTile(const Vehicle *v, TileIndex tile, Trackdir trackdir,bool override_railtype);
+
+
+void NPFFillWithOrderData(NPFFindStationOrTileData *fstd, Vehicle *v, bool reserve_path = false);
 
 
 /*
diff --git a/src/openttd.cpp b/src/openttd.cpp
index 1861d3c..b5a8199 100644
--- a/src/openttd.cpp
+++ b/src/openttd.cpp
@@ -2449,6 +2449,46 @@ bool AfterLoadGame()
 		}
 	}
 
+	/* Move the signal variant back up one bit for PBS. We don't convert the old PBS
+	 * format here, as an old layout wouldn't work properly anyway. To be safe, we
+	 * clear any possible PBS reservations as well. */
+	if (CheckSavegameVersion(99)) {
+		for (TileIndex t = 0; t < map_size; t++) {
+			switch (GetTileType(t)) {
+				case MP_RAILWAY:
+					if (HasSignals(t)) {
+						/* move the signal variant */
+						SetSignalVariant(t, TRACK_UPPER, HasBit(_m[t].m2, 2) ? SIG_SEMAPHORE : SIG_ELECTRIC);
+						SetSignalVariant(t, TRACK_LOWER, HasBit(_m[t].m2, 6) ? SIG_SEMAPHORE : SIG_ELECTRIC);
+						ClrBit(_m[t].m2, 2);
+						ClrBit(_m[t].m2, 6);
+					}
+
+					/* Clear PBS reservation on track */
+					if (IsRailDepot(t) ||IsRailWaypoint(t)) {
+						SetWaypointReservation(t, false);
+					} else {
+						SetTrackReservation(t, TRACK_BIT_NONE);
+					}
+					break;
+
+				case MP_ROAD: /* Clear PBS reservation on crossing */
+					if (IsLevelCrossing(t)) SetCrossingReservation(t, false);
+					break;
+
+				case MP_STATION: /* Clear PBS reservation on station */
+					if (IsRailwayStation(t)) SetRailwayStationReservation(t, false);
+					break;
+
+				case MP_TUNNELBRIDGE: /* Clear PBS reservation on tunnels/birdges */
+					if (GetTunnelBridgeTransportType(t) == TRANSPORT_RAIL) SetTunnelBridgeReservation(t, false);
+					break;
+
+				default: break;
+			}
+		}
+	}
+
 	if (_debug_gamelog_level > 0) GamelogPrintDebug();
 
 	return InitializeWindowsAndCaches();
diff --git a/src/order_cmd.cpp b/src/order_cmd.cpp
index 01e0fec..f56def4 100644
--- a/src/order_cmd.cpp
+++ b/src/order_cmd.cpp
@@ -1618,7 +1618,7 @@ static bool OrderConditionCompare(OrderConditionComparator occ, int variable, in
  * @param v the vehicle to update
  * @return index of next order to jump to, or INVALID_VEH_ORDER_ID to use the next order
  */
-static VehicleOrderID ProcessConditionalOrder(const Order *order, const Vehicle *v)
+VehicleOrderID ProcessConditionalOrder(const Order *order, const Vehicle *v)
 {
 	if (order->GetType() != OT_CONDITIONAL) return INVALID_VEH_ORDER_ID;
 
@@ -1644,7 +1644,7 @@ static VehicleOrderID ProcessConditionalOrder(const Order *order, const Vehicle
  * @param order the order the vehicle currently has
  * @param v the vehicle to update
  */
-static bool UpdateOrderDest(Vehicle *v, const Order *order)
+bool UpdateOrderDest(Vehicle *v, const Order *order)
 {
 	switch (order->GetType()) {
 		case OT_GOTO_STATION:
diff --git a/src/order_func.h b/src/order_func.h
index 8d145da..d32a05d 100644
--- a/src/order_func.h
+++ b/src/order_func.h
@@ -37,6 +37,8 @@ bool VehicleHasDepotOrders(const Vehicle *v);
 void CheckOrders(const Vehicle*);
 void DeleteVehicleOrders(Vehicle *v);
 bool ProcessOrders(Vehicle *v);
+bool UpdateOrderDest(Vehicle *v, const Order *order);
+VehicleOrderID ProcessConditionalOrder(const Order *order, const Vehicle *v);
 
 void DrawOrderString(const Vehicle *v, const Order *order, int order_index, int y, bool selected, bool timetable);
 
diff --git a/src/pathfind.cpp b/src/pathfind.cpp
index 9757b09..e6a27df 100644
--- a/src/pathfind.cpp
+++ b/src/pathfind.cpp
@@ -674,7 +674,7 @@ start_at:
 			if (HasSignals(tile)) {
 				if (!HasSignalOnTrackdir(tile, track)) {
 					/* if one way signal not pointing towards us, stop going in this direction => End of rail segment. */
-					if (HasSignalOnTrackdir(tile, ReverseTrackdir(track))) {
+					if (HasSignalOnTrackdir(tile, ReverseTrackdir(track)) && IsOnewaySignal(tile, TrackdirToTrack(track))) {
 						bits = TRACK_BIT_NONE;
 						break;
 					}
